package bcn.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import bcn.services.LangGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalLangParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_JAVA_GENERIC_TYPES", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'package'", "';'", "'controller'", "'behavior'", "'('", "','", "')'", "'{'", "'input'", "'}'", "'output'", "':'", "'buffer-size'", "'='", "'influence'", "'['", "']'", "'min'", "'max'", "'dec'", "'connect'", "'to'", "'.'", "'-'", "'e'", "'E'"
    };
    public static final int RULE_ID=4;
    public static final int T__29=29;
    public static final int T__28=28;
    public static final int T__27=27;
    public static final int T__26=26;
    public static final int T__25=25;
    public static final int T__24=24;
    public static final int T__23=23;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=11;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=9;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=8;
    public static final int T__30=30;
    public static final int T__19=19;
    public static final int T__31=31;
    public static final int RULE_STRING=7;
    public static final int T__32=32;
    public static final int T__33=33;
    public static final int T__16=16;
    public static final int T__34=34;
    public static final int T__15=15;
    public static final int T__35=35;
    public static final int T__18=18;
    public static final int T__36=36;
    public static final int T__17=17;
    public static final int T__37=37;
    public static final int T__12=12;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=6;
    public static final int RULE_WS=10;
    public static final int RULE_JAVA_GENERIC_TYPES=5;

    // delegates
    // delegators


        public InternalLangParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalLangParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalLangParser.tokenNames; }
    public String getGrammarFileName() { return "../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g"; }



     	private LangGrammarAccess grammarAccess;
     	
        public InternalLangParser(TokenStream input, LangGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Controller";	
       	}
       	
       	@Override
       	protected LangGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleController"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:67:1: entryRuleController returns [EObject current=null] : iv_ruleController= ruleController EOF ;
    public final EObject entryRuleController() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleController = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:68:2: (iv_ruleController= ruleController EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:69:2: iv_ruleController= ruleController EOF
            {
             newCompositeNode(grammarAccess.getControllerRule()); 
            pushFollow(FOLLOW_ruleController_in_entryRuleController75);
            iv_ruleController=ruleController();

            state._fsp--;

             current =iv_ruleController; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleController85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleController"


    // $ANTLR start "ruleController"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:76:1: ruleController returns [EObject current=null] : (otherlv_0= 'package' ( (lv_pckg_1_0= ruleFullID ) ) otherlv_2= ';' otherlv_3= 'controller' ( (lv_name_4_0= RULE_ID ) ) otherlv_5= ';' ( (lv_decls_6_0= ruleDeclaration ) )* ) ;
    public final EObject ruleController() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token lv_name_4_0=null;
        Token otherlv_5=null;
        AntlrDatatypeRuleToken lv_pckg_1_0 = null;

        EObject lv_decls_6_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:79:28: ( (otherlv_0= 'package' ( (lv_pckg_1_0= ruleFullID ) ) otherlv_2= ';' otherlv_3= 'controller' ( (lv_name_4_0= RULE_ID ) ) otherlv_5= ';' ( (lv_decls_6_0= ruleDeclaration ) )* ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:80:1: (otherlv_0= 'package' ( (lv_pckg_1_0= ruleFullID ) ) otherlv_2= ';' otherlv_3= 'controller' ( (lv_name_4_0= RULE_ID ) ) otherlv_5= ';' ( (lv_decls_6_0= ruleDeclaration ) )* )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:80:1: (otherlv_0= 'package' ( (lv_pckg_1_0= ruleFullID ) ) otherlv_2= ';' otherlv_3= 'controller' ( (lv_name_4_0= RULE_ID ) ) otherlv_5= ';' ( (lv_decls_6_0= ruleDeclaration ) )* )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:80:3: otherlv_0= 'package' ( (lv_pckg_1_0= ruleFullID ) ) otherlv_2= ';' otherlv_3= 'controller' ( (lv_name_4_0= RULE_ID ) ) otherlv_5= ';' ( (lv_decls_6_0= ruleDeclaration ) )*
            {
            otherlv_0=(Token)match(input,12,FOLLOW_12_in_ruleController122); 

                	newLeafNode(otherlv_0, grammarAccess.getControllerAccess().getPackageKeyword_0());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:84:1: ( (lv_pckg_1_0= ruleFullID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:85:1: (lv_pckg_1_0= ruleFullID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:85:1: (lv_pckg_1_0= ruleFullID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:86:3: lv_pckg_1_0= ruleFullID
            {
             
            	        newCompositeNode(grammarAccess.getControllerAccess().getPckgFullIDParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_ruleFullID_in_ruleController143);
            lv_pckg_1_0=ruleFullID();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getControllerRule());
            	        }
                   		set(
                   			current, 
                   			"pckg",
                    		lv_pckg_1_0, 
                    		"FullID");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_2=(Token)match(input,13,FOLLOW_13_in_ruleController155); 

                	newLeafNode(otherlv_2, grammarAccess.getControllerAccess().getSemicolonKeyword_2());
                
            otherlv_3=(Token)match(input,14,FOLLOW_14_in_ruleController167); 

                	newLeafNode(otherlv_3, grammarAccess.getControllerAccess().getControllerKeyword_3());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:110:1: ( (lv_name_4_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:111:1: (lv_name_4_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:111:1: (lv_name_4_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:112:3: lv_name_4_0= RULE_ID
            {
            lv_name_4_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleController184); 

            			newLeafNode(lv_name_4_0, grammarAccess.getControllerAccess().getNameIDTerminalRuleCall_4_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getControllerRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_4_0, 
                    		"ID");
            	    

            }


            }

            otherlv_5=(Token)match(input,13,FOLLOW_13_in_ruleController201); 

                	newLeafNode(otherlv_5, grammarAccess.getControllerAccess().getSemicolonKeyword_5());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:132:1: ( (lv_decls_6_0= ruleDeclaration ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==RULE_ID||LA1_0==15||LA1_0==32) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:133:1: (lv_decls_6_0= ruleDeclaration )
            	    {
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:133:1: (lv_decls_6_0= ruleDeclaration )
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:134:3: lv_decls_6_0= ruleDeclaration
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getControllerAccess().getDeclsDeclarationParserRuleCall_6_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleDeclaration_in_ruleController222);
            	    lv_decls_6_0=ruleDeclaration();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getControllerRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"decls",
            	            		lv_decls_6_0, 
            	            		"Declaration");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleController"


    // $ANTLR start "entryRuleDeclaration"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:158:1: entryRuleDeclaration returns [EObject current=null] : iv_ruleDeclaration= ruleDeclaration EOF ;
    public final EObject entryRuleDeclaration() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDeclaration = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:159:2: (iv_ruleDeclaration= ruleDeclaration EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:160:2: iv_ruleDeclaration= ruleDeclaration EOF
            {
             newCompositeNode(grammarAccess.getDeclarationRule()); 
            pushFollow(FOLLOW_ruleDeclaration_in_entryRuleDeclaration259);
            iv_ruleDeclaration=ruleDeclaration();

            state._fsp--;

             current =iv_ruleDeclaration; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleDeclaration269); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDeclaration"


    // $ANTLR start "ruleDeclaration"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:167:1: ruleDeclaration returns [EObject current=null] : (this_BehaviorDef_0= ruleBehaviorDef | this_Instance_1= ruleInstance | this_Connection_2= ruleConnection ) ;
    public final EObject ruleDeclaration() throws RecognitionException {
        EObject current = null;

        EObject this_BehaviorDef_0 = null;

        EObject this_Instance_1 = null;

        EObject this_Connection_2 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:170:28: ( (this_BehaviorDef_0= ruleBehaviorDef | this_Instance_1= ruleInstance | this_Connection_2= ruleConnection ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:171:1: (this_BehaviorDef_0= ruleBehaviorDef | this_Instance_1= ruleInstance | this_Connection_2= ruleConnection )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:171:1: (this_BehaviorDef_0= ruleBehaviorDef | this_Instance_1= ruleInstance | this_Connection_2= ruleConnection )
            int alt2=3;
            switch ( input.LA(1) ) {
            case 15:
                {
                alt2=1;
                }
                break;
            case RULE_ID:
                {
                alt2=2;
                }
                break;
            case 32:
                {
                alt2=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:172:5: this_BehaviorDef_0= ruleBehaviorDef
                    {
                     
                            newCompositeNode(grammarAccess.getDeclarationAccess().getBehaviorDefParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_ruleBehaviorDef_in_ruleDeclaration316);
                    this_BehaviorDef_0=ruleBehaviorDef();

                    state._fsp--;

                     
                            current = this_BehaviorDef_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:182:5: this_Instance_1= ruleInstance
                    {
                     
                            newCompositeNode(grammarAccess.getDeclarationAccess().getInstanceParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_ruleInstance_in_ruleDeclaration343);
                    this_Instance_1=ruleInstance();

                    state._fsp--;

                     
                            current = this_Instance_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 3 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:192:5: this_Connection_2= ruleConnection
                    {
                     
                            newCompositeNode(grammarAccess.getDeclarationAccess().getConnectionParserRuleCall_2()); 
                        
                    pushFollow(FOLLOW_ruleConnection_in_ruleDeclaration370);
                    this_Connection_2=ruleConnection();

                    state._fsp--;

                     
                            current = this_Connection_2; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDeclaration"


    // $ANTLR start "entryRuleBehaviorDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:208:1: entryRuleBehaviorDef returns [EObject current=null] : iv_ruleBehaviorDef= ruleBehaviorDef EOF ;
    public final EObject entryRuleBehaviorDef() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleBehaviorDef = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:209:2: (iv_ruleBehaviorDef= ruleBehaviorDef EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:210:2: iv_ruleBehaviorDef= ruleBehaviorDef EOF
            {
             newCompositeNode(grammarAccess.getBehaviorDefRule()); 
            pushFollow(FOLLOW_ruleBehaviorDef_in_entryRuleBehaviorDef405);
            iv_ruleBehaviorDef=ruleBehaviorDef();

            state._fsp--;

             current =iv_ruleBehaviorDef; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleBehaviorDef415); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleBehaviorDef"


    // $ANTLR start "ruleBehaviorDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:217:1: ruleBehaviorDef returns [EObject current=null] : (otherlv_0= 'behavior' ( (lv_name_1_0= RULE_ID ) ) ( (lv_types_2_0= RULE_JAVA_GENERIC_TYPES ) )? (otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')' )? otherlv_8= '{' (otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}' )? (otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}' )? otherlv_19= '}' ) ;
    public final EObject ruleBehaviorDef() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token lv_types_2_0=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        Token otherlv_13=null;
        Token otherlv_14=null;
        Token otherlv_15=null;
        Token otherlv_17=null;
        Token otherlv_18=null;
        Token otherlv_19=null;
        EObject lv_params_4_0 = null;

        EObject lv_params_6_0 = null;

        EObject lv_inputs_11_0 = null;

        EObject lv_outputs_16_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:220:28: ( (otherlv_0= 'behavior' ( (lv_name_1_0= RULE_ID ) ) ( (lv_types_2_0= RULE_JAVA_GENERIC_TYPES ) )? (otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')' )? otherlv_8= '{' (otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}' )? (otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}' )? otherlv_19= '}' ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:221:1: (otherlv_0= 'behavior' ( (lv_name_1_0= RULE_ID ) ) ( (lv_types_2_0= RULE_JAVA_GENERIC_TYPES ) )? (otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')' )? otherlv_8= '{' (otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}' )? (otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}' )? otherlv_19= '}' )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:221:1: (otherlv_0= 'behavior' ( (lv_name_1_0= RULE_ID ) ) ( (lv_types_2_0= RULE_JAVA_GENERIC_TYPES ) )? (otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')' )? otherlv_8= '{' (otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}' )? (otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}' )? otherlv_19= '}' )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:221:3: otherlv_0= 'behavior' ( (lv_name_1_0= RULE_ID ) ) ( (lv_types_2_0= RULE_JAVA_GENERIC_TYPES ) )? (otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')' )? otherlv_8= '{' (otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}' )? (otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}' )? otherlv_19= '}'
            {
            otherlv_0=(Token)match(input,15,FOLLOW_15_in_ruleBehaviorDef452); 

                	newLeafNode(otherlv_0, grammarAccess.getBehaviorDefAccess().getBehaviorKeyword_0());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:225:1: ( (lv_name_1_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:226:1: (lv_name_1_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:226:1: (lv_name_1_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:227:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleBehaviorDef469); 

            			newLeafNode(lv_name_1_0, grammarAccess.getBehaviorDefAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getBehaviorDefRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:243:2: ( (lv_types_2_0= RULE_JAVA_GENERIC_TYPES ) )?
            int alt3=2;
            int LA3_0 = input.LA(1);

            if ( (LA3_0==RULE_JAVA_GENERIC_TYPES) ) {
                alt3=1;
            }
            switch (alt3) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:244:1: (lv_types_2_0= RULE_JAVA_GENERIC_TYPES )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:244:1: (lv_types_2_0= RULE_JAVA_GENERIC_TYPES )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:245:3: lv_types_2_0= RULE_JAVA_GENERIC_TYPES
                    {
                    lv_types_2_0=(Token)match(input,RULE_JAVA_GENERIC_TYPES,FOLLOW_RULE_JAVA_GENERIC_TYPES_in_ruleBehaviorDef491); 

                    			newLeafNode(lv_types_2_0, grammarAccess.getBehaviorDefAccess().getTypesJAVA_GENERIC_TYPESTerminalRuleCall_2_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getBehaviorDefRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"types",
                            		lv_types_2_0, 
                            		"JAVA_GENERIC_TYPES");
                    	    

                    }


                    }
                    break;

            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:261:3: (otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')' )?
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==16) ) {
                alt6=1;
            }
            switch (alt6) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:261:5: otherlv_3= '(' ( (lv_params_4_0= ruleJavaParam ) )? (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )* otherlv_7= ')'
                    {
                    otherlv_3=(Token)match(input,16,FOLLOW_16_in_ruleBehaviorDef510); 

                        	newLeafNode(otherlv_3, grammarAccess.getBehaviorDefAccess().getLeftParenthesisKeyword_3_0());
                        
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:265:1: ( (lv_params_4_0= ruleJavaParam ) )?
                    int alt4=2;
                    int LA4_0 = input.LA(1);

                    if ( (LA4_0==RULE_ID) ) {
                        alt4=1;
                    }
                    switch (alt4) {
                        case 1 :
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:266:1: (lv_params_4_0= ruleJavaParam )
                            {
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:266:1: (lv_params_4_0= ruleJavaParam )
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:267:3: lv_params_4_0= ruleJavaParam
                            {
                             
                            	        newCompositeNode(grammarAccess.getBehaviorDefAccess().getParamsJavaParamParserRuleCall_3_1_0()); 
                            	    
                            pushFollow(FOLLOW_ruleJavaParam_in_ruleBehaviorDef531);
                            lv_params_4_0=ruleJavaParam();

                            state._fsp--;


                            	        if (current==null) {
                            	            current = createModelElementForParent(grammarAccess.getBehaviorDefRule());
                            	        }
                                   		add(
                                   			current, 
                                   			"params",
                                    		lv_params_4_0, 
                                    		"JavaParam");
                            	        afterParserOrEnumRuleCall();
                            	    

                            }


                            }
                            break;

                    }

                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:283:3: (otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) ) )*
                    loop5:
                    do {
                        int alt5=2;
                        int LA5_0 = input.LA(1);

                        if ( (LA5_0==17) ) {
                            alt5=1;
                        }


                        switch (alt5) {
                    	case 1 :
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:283:5: otherlv_5= ',' ( (lv_params_6_0= ruleJavaParam ) )
                    	    {
                    	    otherlv_5=(Token)match(input,17,FOLLOW_17_in_ruleBehaviorDef545); 

                    	        	newLeafNode(otherlv_5, grammarAccess.getBehaviorDefAccess().getCommaKeyword_3_2_0());
                    	        
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:287:1: ( (lv_params_6_0= ruleJavaParam ) )
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:288:1: (lv_params_6_0= ruleJavaParam )
                    	    {
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:288:1: (lv_params_6_0= ruleJavaParam )
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:289:3: lv_params_6_0= ruleJavaParam
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getBehaviorDefAccess().getParamsJavaParamParserRuleCall_3_2_1_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleJavaParam_in_ruleBehaviorDef566);
                    	    lv_params_6_0=ruleJavaParam();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getBehaviorDefRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"params",
                    	            		lv_params_6_0, 
                    	            		"JavaParam");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop5;
                        }
                    } while (true);

                    otherlv_7=(Token)match(input,18,FOLLOW_18_in_ruleBehaviorDef580); 

                        	newLeafNode(otherlv_7, grammarAccess.getBehaviorDefAccess().getRightParenthesisKeyword_3_3());
                        

                    }
                    break;

            }

            otherlv_8=(Token)match(input,19,FOLLOW_19_in_ruleBehaviorDef594); 

                	newLeafNode(otherlv_8, grammarAccess.getBehaviorDefAccess().getLeftCurlyBracketKeyword_4());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:313:1: (otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}' )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==20) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:313:3: otherlv_9= 'input' otherlv_10= '{' ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )* otherlv_13= '}'
                    {
                    otherlv_9=(Token)match(input,20,FOLLOW_20_in_ruleBehaviorDef607); 

                        	newLeafNode(otherlv_9, grammarAccess.getBehaviorDefAccess().getInputKeyword_5_0());
                        
                    otherlv_10=(Token)match(input,19,FOLLOW_19_in_ruleBehaviorDef619); 

                        	newLeafNode(otherlv_10, grammarAccess.getBehaviorDefAccess().getLeftCurlyBracketKeyword_5_1());
                        
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:321:1: ( ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';' )*
                    loop7:
                    do {
                        int alt7=2;
                        int LA7_0 = input.LA(1);

                        if ( (LA7_0==RULE_ID||LA7_0==26) ) {
                            alt7=1;
                        }


                        switch (alt7) {
                    	case 1 :
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:321:2: ( (lv_inputs_11_0= ruleInputPortDef ) ) otherlv_12= ';'
                    	    {
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:321:2: ( (lv_inputs_11_0= ruleInputPortDef ) )
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:322:1: (lv_inputs_11_0= ruleInputPortDef )
                    	    {
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:322:1: (lv_inputs_11_0= ruleInputPortDef )
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:323:3: lv_inputs_11_0= ruleInputPortDef
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getBehaviorDefAccess().getInputsInputPortDefParserRuleCall_5_2_0_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleInputPortDef_in_ruleBehaviorDef641);
                    	    lv_inputs_11_0=ruleInputPortDef();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getBehaviorDefRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"inputs",
                    	            		lv_inputs_11_0, 
                    	            		"InputPortDef");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }

                    	    otherlv_12=(Token)match(input,13,FOLLOW_13_in_ruleBehaviorDef653); 

                    	        	newLeafNode(otherlv_12, grammarAccess.getBehaviorDefAccess().getSemicolonKeyword_5_2_1());
                    	        

                    	    }
                    	    break;

                    	default :
                    	    break loop7;
                        }
                    } while (true);

                    otherlv_13=(Token)match(input,21,FOLLOW_21_in_ruleBehaviorDef667); 

                        	newLeafNode(otherlv_13, grammarAccess.getBehaviorDefAccess().getRightCurlyBracketKeyword_5_3());
                        

                    }
                    break;

            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:347:3: (otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}' )?
            int alt10=2;
            int LA10_0 = input.LA(1);

            if ( (LA10_0==22) ) {
                alt10=1;
            }
            switch (alt10) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:347:5: otherlv_14= 'output' otherlv_15= '{' ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )* otherlv_18= '}'
                    {
                    otherlv_14=(Token)match(input,22,FOLLOW_22_in_ruleBehaviorDef682); 

                        	newLeafNode(otherlv_14, grammarAccess.getBehaviorDefAccess().getOutputKeyword_6_0());
                        
                    otherlv_15=(Token)match(input,19,FOLLOW_19_in_ruleBehaviorDef694); 

                        	newLeafNode(otherlv_15, grammarAccess.getBehaviorDefAccess().getLeftCurlyBracketKeyword_6_1());
                        
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:355:1: ( ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';' )*
                    loop9:
                    do {
                        int alt9=2;
                        int LA9_0 = input.LA(1);

                        if ( (LA9_0==RULE_ID) ) {
                            alt9=1;
                        }


                        switch (alt9) {
                    	case 1 :
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:355:2: ( (lv_outputs_16_0= rulePortDef ) ) otherlv_17= ';'
                    	    {
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:355:2: ( (lv_outputs_16_0= rulePortDef ) )
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:356:1: (lv_outputs_16_0= rulePortDef )
                    	    {
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:356:1: (lv_outputs_16_0= rulePortDef )
                    	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:357:3: lv_outputs_16_0= rulePortDef
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getBehaviorDefAccess().getOutputsPortDefParserRuleCall_6_2_0_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_rulePortDef_in_ruleBehaviorDef716);
                    	    lv_outputs_16_0=rulePortDef();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getBehaviorDefRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"outputs",
                    	            		lv_outputs_16_0, 
                    	            		"PortDef");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }

                    	    otherlv_17=(Token)match(input,13,FOLLOW_13_in_ruleBehaviorDef728); 

                    	        	newLeafNode(otherlv_17, grammarAccess.getBehaviorDefAccess().getSemicolonKeyword_6_2_1());
                    	        

                    	    }
                    	    break;

                    	default :
                    	    break loop9;
                        }
                    } while (true);

                    otherlv_18=(Token)match(input,21,FOLLOW_21_in_ruleBehaviorDef742); 

                        	newLeafNode(otherlv_18, grammarAccess.getBehaviorDefAccess().getRightCurlyBracketKeyword_6_3());
                        

                    }
                    break;

            }

            otherlv_19=(Token)match(input,21,FOLLOW_21_in_ruleBehaviorDef756); 

                	newLeafNode(otherlv_19, grammarAccess.getBehaviorDefAccess().getRightCurlyBracketKeyword_7());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleBehaviorDef"


    // $ANTLR start "entryRuleJavaParam"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:393:1: entryRuleJavaParam returns [EObject current=null] : iv_ruleJavaParam= ruleJavaParam EOF ;
    public final EObject entryRuleJavaParam() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleJavaParam = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:394:2: (iv_ruleJavaParam= ruleJavaParam EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:395:2: iv_ruleJavaParam= ruleJavaParam EOF
            {
             newCompositeNode(grammarAccess.getJavaParamRule()); 
            pushFollow(FOLLOW_ruleJavaParam_in_entryRuleJavaParam792);
            iv_ruleJavaParam=ruleJavaParam();

            state._fsp--;

             current =iv_ruleJavaParam; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleJavaParam802); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleJavaParam"


    // $ANTLR start "ruleJavaParam"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:402:1: ruleJavaParam returns [EObject current=null] : ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) ) ;
    public final EObject ruleJavaParam() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        AntlrDatatypeRuleToken lv_type_0_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:405:28: ( ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:406:1: ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:406:1: ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:406:2: ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:406:2: ( (lv_type_0_0= ruleJavaType ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:407:1: (lv_type_0_0= ruleJavaType )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:407:1: (lv_type_0_0= ruleJavaType )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:408:3: lv_type_0_0= ruleJavaType
            {
             
            	        newCompositeNode(grammarAccess.getJavaParamAccess().getTypeJavaTypeParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_ruleJavaType_in_ruleJavaParam848);
            lv_type_0_0=ruleJavaType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getJavaParamRule());
            	        }
                   		set(
                   			current, 
                   			"type",
                    		lv_type_0_0, 
                    		"JavaType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:424:2: ( (lv_name_1_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:425:1: (lv_name_1_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:425:1: (lv_name_1_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:426:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleJavaParam865); 

            			newLeafNode(lv_name_1_0, grammarAccess.getJavaParamAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getJavaParamRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleJavaParam"


    // $ANTLR start "entryRuleInputPortDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:450:1: entryRuleInputPortDef returns [EObject current=null] : iv_ruleInputPortDef= ruleInputPortDef EOF ;
    public final EObject entryRuleInputPortDef() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleInputPortDef = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:451:2: (iv_ruleInputPortDef= ruleInputPortDef EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:452:2: iv_ruleInputPortDef= ruleInputPortDef EOF
            {
             newCompositeNode(grammarAccess.getInputPortDefRule()); 
            pushFollow(FOLLOW_ruleInputPortDef_in_entryRuleInputPortDef906);
            iv_ruleInputPortDef=ruleInputPortDef();

            state._fsp--;

             current =iv_ruleInputPortDef; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleInputPortDef916); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleInputPortDef"


    // $ANTLR start "ruleInputPortDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:459:1: ruleInputPortDef returns [EObject current=null] : ( ( (lv_influence_0_0= ruleInfluenceDef ) ) | ( ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )? ) ) ;
    public final EObject ruleInputPortDef() throws RecognitionException {
        EObject current = null;

        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        EObject lv_influence_0_0 = null;

        EObject lv_port_1_0 = null;

        AntlrDatatypeRuleToken lv_buffer_5_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:462:28: ( ( ( (lv_influence_0_0= ruleInfluenceDef ) ) | ( ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )? ) ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:463:1: ( ( (lv_influence_0_0= ruleInfluenceDef ) ) | ( ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )? ) )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:463:1: ( ( (lv_influence_0_0= ruleInfluenceDef ) ) | ( ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )? ) )
            int alt12=2;
            int LA12_0 = input.LA(1);

            if ( (LA12_0==26) ) {
                alt12=1;
            }
            else if ( (LA12_0==RULE_ID) ) {
                alt12=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 12, 0, input);

                throw nvae;
            }
            switch (alt12) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:463:2: ( (lv_influence_0_0= ruleInfluenceDef ) )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:463:2: ( (lv_influence_0_0= ruleInfluenceDef ) )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:464:1: (lv_influence_0_0= ruleInfluenceDef )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:464:1: (lv_influence_0_0= ruleInfluenceDef )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:465:3: lv_influence_0_0= ruleInfluenceDef
                    {
                     
                    	        newCompositeNode(grammarAccess.getInputPortDefAccess().getInfluenceInfluenceDefParserRuleCall_0_0()); 
                    	    
                    pushFollow(FOLLOW_ruleInfluenceDef_in_ruleInputPortDef962);
                    lv_influence_0_0=ruleInfluenceDef();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getInputPortDefRule());
                    	        }
                           		set(
                           			current, 
                           			"influence",
                            		lv_influence_0_0, 
                            		"InfluenceDef");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;
                case 2 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:482:6: ( ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )? )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:482:6: ( ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )? )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:482:7: ( (lv_port_1_0= rulePortDef ) ) (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )?
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:482:7: ( (lv_port_1_0= rulePortDef ) )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:483:1: (lv_port_1_0= rulePortDef )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:483:1: (lv_port_1_0= rulePortDef )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:484:3: lv_port_1_0= rulePortDef
                    {
                     
                    	        newCompositeNode(grammarAccess.getInputPortDefAccess().getPortPortDefParserRuleCall_1_0_0()); 
                    	    
                    pushFollow(FOLLOW_rulePortDef_in_ruleInputPortDef990);
                    lv_port_1_0=rulePortDef();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getInputPortDefRule());
                    	        }
                           		set(
                           			current, 
                           			"port",
                            		lv_port_1_0, 
                            		"PortDef");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:500:2: (otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) ) )?
                    int alt11=2;
                    int LA11_0 = input.LA(1);

                    if ( (LA11_0==23) ) {
                        alt11=1;
                    }
                    switch (alt11) {
                        case 1 :
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:500:4: otherlv_2= ':' otherlv_3= 'buffer-size' otherlv_4= '=' ( (lv_buffer_5_0= ruleJavaIntExpr ) )
                            {
                            otherlv_2=(Token)match(input,23,FOLLOW_23_in_ruleInputPortDef1003); 

                                	newLeafNode(otherlv_2, grammarAccess.getInputPortDefAccess().getColonKeyword_1_1_0());
                                
                            otherlv_3=(Token)match(input,24,FOLLOW_24_in_ruleInputPortDef1015); 

                                	newLeafNode(otherlv_3, grammarAccess.getInputPortDefAccess().getBufferSizeKeyword_1_1_1());
                                
                            otherlv_4=(Token)match(input,25,FOLLOW_25_in_ruleInputPortDef1027); 

                                	newLeafNode(otherlv_4, grammarAccess.getInputPortDefAccess().getEqualsSignKeyword_1_1_2());
                                
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:512:1: ( (lv_buffer_5_0= ruleJavaIntExpr ) )
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:513:1: (lv_buffer_5_0= ruleJavaIntExpr )
                            {
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:513:1: (lv_buffer_5_0= ruleJavaIntExpr )
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:514:3: lv_buffer_5_0= ruleJavaIntExpr
                            {
                             
                            	        newCompositeNode(grammarAccess.getInputPortDefAccess().getBufferJavaIntExprParserRuleCall_1_1_3_0()); 
                            	    
                            pushFollow(FOLLOW_ruleJavaIntExpr_in_ruleInputPortDef1048);
                            lv_buffer_5_0=ruleJavaIntExpr();

                            state._fsp--;


                            	        if (current==null) {
                            	            current = createModelElementForParent(grammarAccess.getInputPortDefRule());
                            	        }
                                   		set(
                                   			current, 
                                   			"buffer",
                                    		lv_buffer_5_0, 
                                    		"JavaIntExpr");
                            	        afterParserOrEnumRuleCall();
                            	    

                            }


                            }


                            }
                            break;

                    }


                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleInputPortDef"


    // $ANTLR start "entryRuleInfluenceDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:538:1: entryRuleInfluenceDef returns [EObject current=null] : iv_ruleInfluenceDef= ruleInfluenceDef EOF ;
    public final EObject entryRuleInfluenceDef() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleInfluenceDef = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:539:2: (iv_ruleInfluenceDef= ruleInfluenceDef EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:540:2: iv_ruleInfluenceDef= ruleInfluenceDef EOF
            {
             newCompositeNode(grammarAccess.getInfluenceDefRule()); 
            pushFollow(FOLLOW_ruleInfluenceDef_in_entryRuleInfluenceDef1087);
            iv_ruleInfluenceDef=ruleInfluenceDef();

            state._fsp--;

             current =iv_ruleInfluenceDef; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleInfluenceDef1097); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleInfluenceDef"


    // $ANTLR start "ruleInfluenceDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:547:1: ruleInfluenceDef returns [EObject current=null] : (otherlv_0= 'influence' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? otherlv_5= ':' otherlv_6= 'min' otherlv_7= '=' ( (lv_min_8_0= ruleJavaFloatExpr ) ) otherlv_9= ',' otherlv_10= 'max' otherlv_11= '=' ( (lv_max_12_0= ruleJavaFloatExpr ) ) otherlv_13= ',' otherlv_14= 'dec' otherlv_15= '=' ( (lv_dec_16_0= ruleJavaFloatExpr ) ) ) ;
    public final EObject ruleInfluenceDef() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_13=null;
        Token otherlv_14=null;
        Token otherlv_15=null;
        AntlrDatatypeRuleToken lv_array_3_0 = null;

        AntlrDatatypeRuleToken lv_min_8_0 = null;

        AntlrDatatypeRuleToken lv_max_12_0 = null;

        AntlrDatatypeRuleToken lv_dec_16_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:550:28: ( (otherlv_0= 'influence' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? otherlv_5= ':' otherlv_6= 'min' otherlv_7= '=' ( (lv_min_8_0= ruleJavaFloatExpr ) ) otherlv_9= ',' otherlv_10= 'max' otherlv_11= '=' ( (lv_max_12_0= ruleJavaFloatExpr ) ) otherlv_13= ',' otherlv_14= 'dec' otherlv_15= '=' ( (lv_dec_16_0= ruleJavaFloatExpr ) ) ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:551:1: (otherlv_0= 'influence' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? otherlv_5= ':' otherlv_6= 'min' otherlv_7= '=' ( (lv_min_8_0= ruleJavaFloatExpr ) ) otherlv_9= ',' otherlv_10= 'max' otherlv_11= '=' ( (lv_max_12_0= ruleJavaFloatExpr ) ) otherlv_13= ',' otherlv_14= 'dec' otherlv_15= '=' ( (lv_dec_16_0= ruleJavaFloatExpr ) ) )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:551:1: (otherlv_0= 'influence' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? otherlv_5= ':' otherlv_6= 'min' otherlv_7= '=' ( (lv_min_8_0= ruleJavaFloatExpr ) ) otherlv_9= ',' otherlv_10= 'max' otherlv_11= '=' ( (lv_max_12_0= ruleJavaFloatExpr ) ) otherlv_13= ',' otherlv_14= 'dec' otherlv_15= '=' ( (lv_dec_16_0= ruleJavaFloatExpr ) ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:551:3: otherlv_0= 'influence' ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? otherlv_5= ':' otherlv_6= 'min' otherlv_7= '=' ( (lv_min_8_0= ruleJavaFloatExpr ) ) otherlv_9= ',' otherlv_10= 'max' otherlv_11= '=' ( (lv_max_12_0= ruleJavaFloatExpr ) ) otherlv_13= ',' otherlv_14= 'dec' otherlv_15= '=' ( (lv_dec_16_0= ruleJavaFloatExpr ) )
            {
            otherlv_0=(Token)match(input,26,FOLLOW_26_in_ruleInfluenceDef1134); 

                	newLeafNode(otherlv_0, grammarAccess.getInfluenceDefAccess().getInfluenceKeyword_0());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:555:1: ( (lv_name_1_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:556:1: (lv_name_1_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:556:1: (lv_name_1_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:557:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleInfluenceDef1151); 

            			newLeafNode(lv_name_1_0, grammarAccess.getInfluenceDefAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getInfluenceDefRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:573:2: (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==27) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:573:4: otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']'
                    {
                    otherlv_2=(Token)match(input,27,FOLLOW_27_in_ruleInfluenceDef1169); 

                        	newLeafNode(otherlv_2, grammarAccess.getInfluenceDefAccess().getLeftSquareBracketKeyword_2_0());
                        
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:577:1: ( (lv_array_3_0= ruleJavaIntExpr ) )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:578:1: (lv_array_3_0= ruleJavaIntExpr )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:578:1: (lv_array_3_0= ruleJavaIntExpr )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:579:3: lv_array_3_0= ruleJavaIntExpr
                    {
                     
                    	        newCompositeNode(grammarAccess.getInfluenceDefAccess().getArrayJavaIntExprParserRuleCall_2_1_0()); 
                    	    
                    pushFollow(FOLLOW_ruleJavaIntExpr_in_ruleInfluenceDef1190);
                    lv_array_3_0=ruleJavaIntExpr();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getInfluenceDefRule());
                    	        }
                           		set(
                           			current, 
                           			"array",
                            		lv_array_3_0, 
                            		"JavaIntExpr");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    otherlv_4=(Token)match(input,28,FOLLOW_28_in_ruleInfluenceDef1202); 

                        	newLeafNode(otherlv_4, grammarAccess.getInfluenceDefAccess().getRightSquareBracketKeyword_2_2());
                        

                    }
                    break;

            }

            otherlv_5=(Token)match(input,23,FOLLOW_23_in_ruleInfluenceDef1216); 

                	newLeafNode(otherlv_5, grammarAccess.getInfluenceDefAccess().getColonKeyword_3());
                
            otherlv_6=(Token)match(input,29,FOLLOW_29_in_ruleInfluenceDef1228); 

                	newLeafNode(otherlv_6, grammarAccess.getInfluenceDefAccess().getMinKeyword_4());
                
            otherlv_7=(Token)match(input,25,FOLLOW_25_in_ruleInfluenceDef1240); 

                	newLeafNode(otherlv_7, grammarAccess.getInfluenceDefAccess().getEqualsSignKeyword_5());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:611:1: ( (lv_min_8_0= ruleJavaFloatExpr ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:612:1: (lv_min_8_0= ruleJavaFloatExpr )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:612:1: (lv_min_8_0= ruleJavaFloatExpr )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:613:3: lv_min_8_0= ruleJavaFloatExpr
            {
             
            	        newCompositeNode(grammarAccess.getInfluenceDefAccess().getMinJavaFloatExprParserRuleCall_6_0()); 
            	    
            pushFollow(FOLLOW_ruleJavaFloatExpr_in_ruleInfluenceDef1261);
            lv_min_8_0=ruleJavaFloatExpr();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getInfluenceDefRule());
            	        }
                   		set(
                   			current, 
                   			"min",
                    		lv_min_8_0, 
                    		"JavaFloatExpr");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_9=(Token)match(input,17,FOLLOW_17_in_ruleInfluenceDef1273); 

                	newLeafNode(otherlv_9, grammarAccess.getInfluenceDefAccess().getCommaKeyword_7());
                
            otherlv_10=(Token)match(input,30,FOLLOW_30_in_ruleInfluenceDef1285); 

                	newLeafNode(otherlv_10, grammarAccess.getInfluenceDefAccess().getMaxKeyword_8());
                
            otherlv_11=(Token)match(input,25,FOLLOW_25_in_ruleInfluenceDef1297); 

                	newLeafNode(otherlv_11, grammarAccess.getInfluenceDefAccess().getEqualsSignKeyword_9());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:641:1: ( (lv_max_12_0= ruleJavaFloatExpr ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:642:1: (lv_max_12_0= ruleJavaFloatExpr )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:642:1: (lv_max_12_0= ruleJavaFloatExpr )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:643:3: lv_max_12_0= ruleJavaFloatExpr
            {
             
            	        newCompositeNode(grammarAccess.getInfluenceDefAccess().getMaxJavaFloatExprParserRuleCall_10_0()); 
            	    
            pushFollow(FOLLOW_ruleJavaFloatExpr_in_ruleInfluenceDef1318);
            lv_max_12_0=ruleJavaFloatExpr();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getInfluenceDefRule());
            	        }
                   		set(
                   			current, 
                   			"max",
                    		lv_max_12_0, 
                    		"JavaFloatExpr");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_13=(Token)match(input,17,FOLLOW_17_in_ruleInfluenceDef1330); 

                	newLeafNode(otherlv_13, grammarAccess.getInfluenceDefAccess().getCommaKeyword_11());
                
            otherlv_14=(Token)match(input,31,FOLLOW_31_in_ruleInfluenceDef1342); 

                	newLeafNode(otherlv_14, grammarAccess.getInfluenceDefAccess().getDecKeyword_12());
                
            otherlv_15=(Token)match(input,25,FOLLOW_25_in_ruleInfluenceDef1354); 

                	newLeafNode(otherlv_15, grammarAccess.getInfluenceDefAccess().getEqualsSignKeyword_13());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:671:1: ( (lv_dec_16_0= ruleJavaFloatExpr ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:672:1: (lv_dec_16_0= ruleJavaFloatExpr )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:672:1: (lv_dec_16_0= ruleJavaFloatExpr )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:673:3: lv_dec_16_0= ruleJavaFloatExpr
            {
             
            	        newCompositeNode(grammarAccess.getInfluenceDefAccess().getDecJavaFloatExprParserRuleCall_14_0()); 
            	    
            pushFollow(FOLLOW_ruleJavaFloatExpr_in_ruleInfluenceDef1375);
            lv_dec_16_0=ruleJavaFloatExpr();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getInfluenceDefRule());
            	        }
                   		set(
                   			current, 
                   			"dec",
                    		lv_dec_16_0, 
                    		"JavaFloatExpr");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleInfluenceDef"


    // $ANTLR start "entryRulePortDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:697:1: entryRulePortDef returns [EObject current=null] : iv_rulePortDef= rulePortDef EOF ;
    public final EObject entryRulePortDef() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePortDef = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:698:2: (iv_rulePortDef= rulePortDef EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:699:2: iv_rulePortDef= rulePortDef EOF
            {
             newCompositeNode(grammarAccess.getPortDefRule()); 
            pushFollow(FOLLOW_rulePortDef_in_entryRulePortDef1411);
            iv_rulePortDef=rulePortDef();

            state._fsp--;

             current =iv_rulePortDef; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePortDef1421); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePortDef"


    // $ANTLR start "rulePortDef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:706:1: rulePortDef returns [EObject current=null] : ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? ) ;
    public final EObject rulePortDef() throws RecognitionException {
        EObject current = null;

        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        AntlrDatatypeRuleToken lv_type_0_0 = null;

        AntlrDatatypeRuleToken lv_array_3_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:709:28: ( ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:710:1: ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:710:1: ( ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )? )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:710:2: ( (lv_type_0_0= ruleJavaType ) ) ( (lv_name_1_0= RULE_ID ) ) (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )?
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:710:2: ( (lv_type_0_0= ruleJavaType ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:711:1: (lv_type_0_0= ruleJavaType )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:711:1: (lv_type_0_0= ruleJavaType )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:712:3: lv_type_0_0= ruleJavaType
            {
             
            	        newCompositeNode(grammarAccess.getPortDefAccess().getTypeJavaTypeParserRuleCall_0_0()); 
            	    
            pushFollow(FOLLOW_ruleJavaType_in_rulePortDef1467);
            lv_type_0_0=ruleJavaType();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getPortDefRule());
            	        }
                   		set(
                   			current, 
                   			"type",
                    		lv_type_0_0, 
                    		"JavaType");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:728:2: ( (lv_name_1_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:729:1: (lv_name_1_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:729:1: (lv_name_1_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:730:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePortDef1484); 

            			newLeafNode(lv_name_1_0, grammarAccess.getPortDefAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPortDefRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:746:2: (otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']' )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==27) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:746:4: otherlv_2= '[' ( (lv_array_3_0= ruleJavaIntExpr ) ) otherlv_4= ']'
                    {
                    otherlv_2=(Token)match(input,27,FOLLOW_27_in_rulePortDef1502); 

                        	newLeafNode(otherlv_2, grammarAccess.getPortDefAccess().getLeftSquareBracketKeyword_2_0());
                        
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:750:1: ( (lv_array_3_0= ruleJavaIntExpr ) )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:751:1: (lv_array_3_0= ruleJavaIntExpr )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:751:1: (lv_array_3_0= ruleJavaIntExpr )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:752:3: lv_array_3_0= ruleJavaIntExpr
                    {
                     
                    	        newCompositeNode(grammarAccess.getPortDefAccess().getArrayJavaIntExprParserRuleCall_2_1_0()); 
                    	    
                    pushFollow(FOLLOW_ruleJavaIntExpr_in_rulePortDef1523);
                    lv_array_3_0=ruleJavaIntExpr();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getPortDefRule());
                    	        }
                           		set(
                           			current, 
                           			"array",
                            		lv_array_3_0, 
                            		"JavaIntExpr");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    otherlv_4=(Token)match(input,28,FOLLOW_28_in_rulePortDef1535); 

                        	newLeafNode(otherlv_4, grammarAccess.getPortDefAccess().getRightSquareBracketKeyword_2_2());
                        

                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePortDef"


    // $ANTLR start "entryRuleInstance"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:780:1: entryRuleInstance returns [EObject current=null] : iv_ruleInstance= ruleInstance EOF ;
    public final EObject entryRuleInstance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleInstance = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:781:2: (iv_ruleInstance= ruleInstance EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:782:2: iv_ruleInstance= ruleInstance EOF
            {
             newCompositeNode(grammarAccess.getInstanceRule()); 
            pushFollow(FOLLOW_ruleInstance_in_entryRuleInstance1573);
            iv_ruleInstance=ruleInstance();

            state._fsp--;

             current =iv_ruleInstance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleInstance1583); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleInstance"


    // $ANTLR start "ruleInstance"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:789:1: ruleInstance returns [EObject current=null] : ( ( (lv_behavior_0_0= RULE_ID ) ) ( (lv_types_1_0= RULE_JAVA_GENERIC_TYPES ) )? ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ';' ) ;
    public final EObject ruleInstance() throws RecognitionException {
        EObject current = null;

        Token lv_behavior_0_0=null;
        Token lv_types_1_0=null;
        Token lv_name_2_0=null;
        Token otherlv_3=null;

         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:792:28: ( ( ( (lv_behavior_0_0= RULE_ID ) ) ( (lv_types_1_0= RULE_JAVA_GENERIC_TYPES ) )? ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ';' ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:793:1: ( ( (lv_behavior_0_0= RULE_ID ) ) ( (lv_types_1_0= RULE_JAVA_GENERIC_TYPES ) )? ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ';' )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:793:1: ( ( (lv_behavior_0_0= RULE_ID ) ) ( (lv_types_1_0= RULE_JAVA_GENERIC_TYPES ) )? ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ';' )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:793:2: ( (lv_behavior_0_0= RULE_ID ) ) ( (lv_types_1_0= RULE_JAVA_GENERIC_TYPES ) )? ( (lv_name_2_0= RULE_ID ) ) otherlv_3= ';'
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:793:2: ( (lv_behavior_0_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:794:1: (lv_behavior_0_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:794:1: (lv_behavior_0_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:795:3: lv_behavior_0_0= RULE_ID
            {
            lv_behavior_0_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleInstance1625); 

            			newLeafNode(lv_behavior_0_0, grammarAccess.getInstanceAccess().getBehaviorIDTerminalRuleCall_0_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getInstanceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"behavior",
                    		lv_behavior_0_0, 
                    		"ID");
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:811:2: ( (lv_types_1_0= RULE_JAVA_GENERIC_TYPES ) )?
            int alt15=2;
            int LA15_0 = input.LA(1);

            if ( (LA15_0==RULE_JAVA_GENERIC_TYPES) ) {
                alt15=1;
            }
            switch (alt15) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:812:1: (lv_types_1_0= RULE_JAVA_GENERIC_TYPES )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:812:1: (lv_types_1_0= RULE_JAVA_GENERIC_TYPES )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:813:3: lv_types_1_0= RULE_JAVA_GENERIC_TYPES
                    {
                    lv_types_1_0=(Token)match(input,RULE_JAVA_GENERIC_TYPES,FOLLOW_RULE_JAVA_GENERIC_TYPES_in_ruleInstance1647); 

                    			newLeafNode(lv_types_1_0, grammarAccess.getInstanceAccess().getTypesJAVA_GENERIC_TYPESTerminalRuleCall_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getInstanceRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"types",
                            		lv_types_1_0, 
                            		"JAVA_GENERIC_TYPES");
                    	    

                    }


                    }
                    break;

            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:829:3: ( (lv_name_2_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:830:1: (lv_name_2_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:830:1: (lv_name_2_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:831:3: lv_name_2_0= RULE_ID
            {
            lv_name_2_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleInstance1670); 

            			newLeafNode(lv_name_2_0, grammarAccess.getInstanceAccess().getNameIDTerminalRuleCall_2_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getInstanceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_2_0, 
                    		"ID");
            	    

            }


            }

            otherlv_3=(Token)match(input,13,FOLLOW_13_in_ruleInstance1687); 

                	newLeafNode(otherlv_3, grammarAccess.getInstanceAccess().getSemicolonKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleInstance"


    // $ANTLR start "entryRuleConnection"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:859:1: entryRuleConnection returns [EObject current=null] : iv_ruleConnection= ruleConnection EOF ;
    public final EObject entryRuleConnection() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConnection = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:860:2: (iv_ruleConnection= ruleConnection EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:861:2: iv_ruleConnection= ruleConnection EOF
            {
             newCompositeNode(grammarAccess.getConnectionRule()); 
            pushFollow(FOLLOW_ruleConnection_in_entryRuleConnection1723);
            iv_ruleConnection=ruleConnection();

            state._fsp--;

             current =iv_ruleConnection; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleConnection1733); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConnection"


    // $ANTLR start "ruleConnection"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:868:1: ruleConnection returns [EObject current=null] : (otherlv_0= 'connect' ( (lv_src_1_0= rulePortRef ) ) otherlv_2= 'to' ( (lv_dests_3_0= rulePortRef ) ) (otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) ) )* otherlv_6= ';' ) ;
    public final EObject ruleConnection() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        EObject lv_src_1_0 = null;

        EObject lv_dests_3_0 = null;

        EObject lv_dests_5_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:871:28: ( (otherlv_0= 'connect' ( (lv_src_1_0= rulePortRef ) ) otherlv_2= 'to' ( (lv_dests_3_0= rulePortRef ) ) (otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) ) )* otherlv_6= ';' ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:872:1: (otherlv_0= 'connect' ( (lv_src_1_0= rulePortRef ) ) otherlv_2= 'to' ( (lv_dests_3_0= rulePortRef ) ) (otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) ) )* otherlv_6= ';' )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:872:1: (otherlv_0= 'connect' ( (lv_src_1_0= rulePortRef ) ) otherlv_2= 'to' ( (lv_dests_3_0= rulePortRef ) ) (otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) ) )* otherlv_6= ';' )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:872:3: otherlv_0= 'connect' ( (lv_src_1_0= rulePortRef ) ) otherlv_2= 'to' ( (lv_dests_3_0= rulePortRef ) ) (otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) ) )* otherlv_6= ';'
            {
            otherlv_0=(Token)match(input,32,FOLLOW_32_in_ruleConnection1770); 

                	newLeafNode(otherlv_0, grammarAccess.getConnectionAccess().getConnectKeyword_0());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:876:1: ( (lv_src_1_0= rulePortRef ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:877:1: (lv_src_1_0= rulePortRef )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:877:1: (lv_src_1_0= rulePortRef )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:878:3: lv_src_1_0= rulePortRef
            {
             
            	        newCompositeNode(grammarAccess.getConnectionAccess().getSrcPortRefParserRuleCall_1_0()); 
            	    
            pushFollow(FOLLOW_rulePortRef_in_ruleConnection1791);
            lv_src_1_0=rulePortRef();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getConnectionRule());
            	        }
                   		set(
                   			current, 
                   			"src",
                    		lv_src_1_0, 
                    		"PortRef");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_2=(Token)match(input,33,FOLLOW_33_in_ruleConnection1803); 

                	newLeafNode(otherlv_2, grammarAccess.getConnectionAccess().getToKeyword_2());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:898:1: ( (lv_dests_3_0= rulePortRef ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:899:1: (lv_dests_3_0= rulePortRef )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:899:1: (lv_dests_3_0= rulePortRef )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:900:3: lv_dests_3_0= rulePortRef
            {
             
            	        newCompositeNode(grammarAccess.getConnectionAccess().getDestsPortRefParserRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_rulePortRef_in_ruleConnection1824);
            lv_dests_3_0=rulePortRef();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getConnectionRule());
            	        }
                   		add(
                   			current, 
                   			"dests",
                    		lv_dests_3_0, 
                    		"PortRef");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:916:2: (otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) ) )*
            loop16:
            do {
                int alt16=2;
                int LA16_0 = input.LA(1);

                if ( (LA16_0==17) ) {
                    alt16=1;
                }


                switch (alt16) {
            	case 1 :
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:916:4: otherlv_4= ',' ( (lv_dests_5_0= rulePortRef ) )
            	    {
            	    otherlv_4=(Token)match(input,17,FOLLOW_17_in_ruleConnection1837); 

            	        	newLeafNode(otherlv_4, grammarAccess.getConnectionAccess().getCommaKeyword_4_0());
            	        
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:920:1: ( (lv_dests_5_0= rulePortRef ) )
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:921:1: (lv_dests_5_0= rulePortRef )
            	    {
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:921:1: (lv_dests_5_0= rulePortRef )
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:922:3: lv_dests_5_0= rulePortRef
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getConnectionAccess().getDestsPortRefParserRuleCall_4_1_0()); 
            	    	    
            	    pushFollow(FOLLOW_rulePortRef_in_ruleConnection1858);
            	    lv_dests_5_0=rulePortRef();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getConnectionRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"dests",
            	            		lv_dests_5_0, 
            	            		"PortRef");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop16;
                }
            } while (true);

            otherlv_6=(Token)match(input,13,FOLLOW_13_in_ruleConnection1872); 

                	newLeafNode(otherlv_6, grammarAccess.getConnectionAccess().getSemicolonKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConnection"


    // $ANTLR start "entryRulePortRef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:950:1: entryRulePortRef returns [EObject current=null] : iv_rulePortRef= rulePortRef EOF ;
    public final EObject entryRulePortRef() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePortRef = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:951:2: (iv_rulePortRef= rulePortRef EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:952:2: iv_rulePortRef= rulePortRef EOF
            {
             newCompositeNode(grammarAccess.getPortRefRule()); 
            pushFollow(FOLLOW_rulePortRef_in_entryRulePortRef1908);
            iv_rulePortRef=rulePortRef();

            state._fsp--;

             current =iv_rulePortRef; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePortRef1918); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePortRef"


    // $ANTLR start "rulePortRef"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:959:1: rulePortRef returns [EObject current=null] : ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '.' ( (lv_port_2_0= RULE_ID ) ) (otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']' )? ) ;
    public final EObject rulePortRef() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token lv_port_2_0=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        AntlrDatatypeRuleToken lv_index_4_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:962:28: ( ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '.' ( (lv_port_2_0= RULE_ID ) ) (otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']' )? ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:963:1: ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '.' ( (lv_port_2_0= RULE_ID ) ) (otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']' )? )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:963:1: ( ( (otherlv_0= RULE_ID ) ) otherlv_1= '.' ( (lv_port_2_0= RULE_ID ) ) (otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']' )? )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:963:2: ( (otherlv_0= RULE_ID ) ) otherlv_1= '.' ( (lv_port_2_0= RULE_ID ) ) (otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']' )?
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:963:2: ( (otherlv_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:964:1: (otherlv_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:964:1: (otherlv_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:965:3: otherlv_0= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getPortRefRule());
            	        }
                    
            otherlv_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePortRef1963); 

            		newLeafNode(otherlv_0, grammarAccess.getPortRefAccess().getBehaviorInstanceCrossReference_0_0()); 
            	

            }


            }

            otherlv_1=(Token)match(input,34,FOLLOW_34_in_rulePortRef1975); 

                	newLeafNode(otherlv_1, grammarAccess.getPortRefAccess().getFullStopKeyword_1());
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:980:1: ( (lv_port_2_0= RULE_ID ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:981:1: (lv_port_2_0= RULE_ID )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:981:1: (lv_port_2_0= RULE_ID )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:982:3: lv_port_2_0= RULE_ID
            {
            lv_port_2_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_rulePortRef1992); 

            			newLeafNode(lv_port_2_0, grammarAccess.getPortRefAccess().getPortIDTerminalRuleCall_2_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getPortRefRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"port",
                    		lv_port_2_0, 
                    		"ID");
            	    

            }


            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:998:2: (otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']' )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==27) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:998:4: otherlv_3= '[' ( (lv_index_4_0= ruleJavaIntExpr ) ) otherlv_5= ']'
                    {
                    otherlv_3=(Token)match(input,27,FOLLOW_27_in_rulePortRef2010); 

                        	newLeafNode(otherlv_3, grammarAccess.getPortRefAccess().getLeftSquareBracketKeyword_3_0());
                        
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1002:1: ( (lv_index_4_0= ruleJavaIntExpr ) )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1003:1: (lv_index_4_0= ruleJavaIntExpr )
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1003:1: (lv_index_4_0= ruleJavaIntExpr )
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1004:3: lv_index_4_0= ruleJavaIntExpr
                    {
                     
                    	        newCompositeNode(grammarAccess.getPortRefAccess().getIndexJavaIntExprParserRuleCall_3_1_0()); 
                    	    
                    pushFollow(FOLLOW_ruleJavaIntExpr_in_rulePortRef2031);
                    lv_index_4_0=ruleJavaIntExpr();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getPortRefRule());
                    	        }
                           		set(
                           			current, 
                           			"index",
                            		lv_index_4_0, 
                            		"JavaIntExpr");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    otherlv_5=(Token)match(input,28,FOLLOW_28_in_rulePortRef2043); 

                        	newLeafNode(otherlv_5, grammarAccess.getPortRefAccess().getRightSquareBracketKeyword_3_2());
                        

                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePortRef"


    // $ANTLR start "entryRuleFullID"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1032:1: entryRuleFullID returns [String current=null] : iv_ruleFullID= ruleFullID EOF ;
    public final String entryRuleFullID() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleFullID = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1033:2: (iv_ruleFullID= ruleFullID EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1034:2: iv_ruleFullID= ruleFullID EOF
            {
             newCompositeNode(grammarAccess.getFullIDRule()); 
            pushFollow(FOLLOW_ruleFullID_in_entryRuleFullID2082);
            iv_ruleFullID=ruleFullID();

            state._fsp--;

             current =iv_ruleFullID.getText(); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleFullID2093); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFullID"


    // $ANTLR start "ruleFullID"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1041:1: ruleFullID returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* ) ;
    public final AntlrDatatypeRuleToken ruleFullID() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_ID_0=null;
        Token kw=null;
        Token this_ID_2=null;

         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1044:28: ( (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1045:1: (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1045:1: (this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )* )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1045:6: this_ID_0= RULE_ID (kw= '.' this_ID_2= RULE_ID )*
            {
            this_ID_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleFullID2133); 

            		current.merge(this_ID_0);
                
             
                newLeafNode(this_ID_0, grammarAccess.getFullIDAccess().getIDTerminalRuleCall_0()); 
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1052:1: (kw= '.' this_ID_2= RULE_ID )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==34) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1053:2: kw= '.' this_ID_2= RULE_ID
            	    {
            	    kw=(Token)match(input,34,FOLLOW_34_in_ruleFullID2152); 

            	            current.merge(kw);
            	            newLeafNode(kw, grammarAccess.getFullIDAccess().getFullStopKeyword_1_0()); 
            	        
            	    this_ID_2=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleFullID2167); 

            	    		current.merge(this_ID_2);
            	        
            	     
            	        newLeafNode(this_ID_2, grammarAccess.getFullIDAccess().getIDTerminalRuleCall_1_1()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFullID"


    // $ANTLR start "entryRuleFloat"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1073:1: entryRuleFloat returns [String current=null] : iv_ruleFloat= ruleFloat EOF ;
    public final String entryRuleFloat() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleFloat = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1074:2: (iv_ruleFloat= ruleFloat EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1075:2: iv_ruleFloat= ruleFloat EOF
            {
             newCompositeNode(grammarAccess.getFloatRule()); 
            pushFollow(FOLLOW_ruleFloat_in_entryRuleFloat2215);
            iv_ruleFloat=ruleFloat();

            state._fsp--;

             current =iv_ruleFloat.getText(); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleFloat2226); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleFloat"


    // $ANTLR start "ruleFloat"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1082:1: ruleFloat returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT )? ) ;
    public final AntlrDatatypeRuleToken ruleFloat() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        Token this_INT_1=null;
        Token this_INT_3=null;
        Token this_INT_7=null;

         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1085:28: ( ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT )? ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1086:1: ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT )? )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1086:1: ( (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT )? )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1086:2: (kw= '-' )? this_INT_1= RULE_INT (kw= '.' this_INT_3= RULE_INT )? ( (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT )?
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1086:2: (kw= '-' )?
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==35) ) {
                alt19=1;
            }
            switch (alt19) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1087:2: kw= '-'
                    {
                    kw=(Token)match(input,35,FOLLOW_35_in_ruleFloat2265); 

                            current.merge(kw);
                            newLeafNode(kw, grammarAccess.getFloatAccess().getHyphenMinusKeyword_0()); 
                        

                    }
                    break;

            }

            this_INT_1=(Token)match(input,RULE_INT,FOLLOW_RULE_INT_in_ruleFloat2282); 

            		current.merge(this_INT_1);
                
             
                newLeafNode(this_INT_1, grammarAccess.getFloatAccess().getINTTerminalRuleCall_1()); 
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1099:1: (kw= '.' this_INT_3= RULE_INT )?
            int alt20=2;
            int LA20_0 = input.LA(1);

            if ( (LA20_0==34) ) {
                alt20=1;
            }
            switch (alt20) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1100:2: kw= '.' this_INT_3= RULE_INT
                    {
                    kw=(Token)match(input,34,FOLLOW_34_in_ruleFloat2301); 

                            current.merge(kw);
                            newLeafNode(kw, grammarAccess.getFloatAccess().getFullStopKeyword_2_0()); 
                        
                    this_INT_3=(Token)match(input,RULE_INT,FOLLOW_RULE_INT_in_ruleFloat2316); 

                    		current.merge(this_INT_3);
                        
                     
                        newLeafNode(this_INT_3, grammarAccess.getFloatAccess().getINTTerminalRuleCall_2_1()); 
                        

                    }
                    break;

            }

            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1112:3: ( (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT )?
            int alt23=2;
            int LA23_0 = input.LA(1);

            if ( ((LA23_0>=36 && LA23_0<=37)) ) {
                alt23=1;
            }
            switch (alt23) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1112:4: (kw= 'e' | kw= 'E' ) (kw= '-' )? this_INT_7= RULE_INT
                    {
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1112:4: (kw= 'e' | kw= 'E' )
                    int alt21=2;
                    int LA21_0 = input.LA(1);

                    if ( (LA21_0==36) ) {
                        alt21=1;
                    }
                    else if ( (LA21_0==37) ) {
                        alt21=2;
                    }
                    else {
                        NoViableAltException nvae =
                            new NoViableAltException("", 21, 0, input);

                        throw nvae;
                    }
                    switch (alt21) {
                        case 1 :
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1113:2: kw= 'e'
                            {
                            kw=(Token)match(input,36,FOLLOW_36_in_ruleFloat2338); 

                                    current.merge(kw);
                                    newLeafNode(kw, grammarAccess.getFloatAccess().getEKeyword_3_0_0()); 
                                

                            }
                            break;
                        case 2 :
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1120:2: kw= 'E'
                            {
                            kw=(Token)match(input,37,FOLLOW_37_in_ruleFloat2357); 

                                    current.merge(kw);
                                    newLeafNode(kw, grammarAccess.getFloatAccess().getEKeyword_3_0_1()); 
                                

                            }
                            break;

                    }

                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1125:2: (kw= '-' )?
                    int alt22=2;
                    int LA22_0 = input.LA(1);

                    if ( (LA22_0==35) ) {
                        alt22=1;
                    }
                    switch (alt22) {
                        case 1 :
                            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1126:2: kw= '-'
                            {
                            kw=(Token)match(input,35,FOLLOW_35_in_ruleFloat2372); 

                                    current.merge(kw);
                                    newLeafNode(kw, grammarAccess.getFloatAccess().getHyphenMinusKeyword_3_1()); 
                                

                            }
                            break;

                    }

                    this_INT_7=(Token)match(input,RULE_INT,FOLLOW_RULE_INT_in_ruleFloat2389); 

                    		current.merge(this_INT_7);
                        
                     
                        newLeafNode(this_INT_7, grammarAccess.getFloatAccess().getINTTerminalRuleCall_3_2()); 
                        

                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleFloat"


    // $ANTLR start "entryRuleJavaType"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1146:1: entryRuleJavaType returns [String current=null] : iv_ruleJavaType= ruleJavaType EOF ;
    public final String entryRuleJavaType() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleJavaType = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1147:2: (iv_ruleJavaType= ruleJavaType EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1148:2: iv_ruleJavaType= ruleJavaType EOF
            {
             newCompositeNode(grammarAccess.getJavaTypeRule()); 
            pushFollow(FOLLOW_ruleJavaType_in_entryRuleJavaType2437);
            iv_ruleJavaType=ruleJavaType();

            state._fsp--;

             current =iv_ruleJavaType.getText(); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleJavaType2448); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleJavaType"


    // $ANTLR start "ruleJavaType"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1155:1: ruleJavaType returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_FullID_0= ruleFullID (kw= '[' kw= ']' )* ) ;
    public final AntlrDatatypeRuleToken ruleJavaType() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_FullID_0 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1158:28: ( (this_FullID_0= ruleFullID (kw= '[' kw= ']' )* ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1159:1: (this_FullID_0= ruleFullID (kw= '[' kw= ']' )* )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1159:1: (this_FullID_0= ruleFullID (kw= '[' kw= ']' )* )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1160:5: this_FullID_0= ruleFullID (kw= '[' kw= ']' )*
            {
             
                    newCompositeNode(grammarAccess.getJavaTypeAccess().getFullIDParserRuleCall_0()); 
                
            pushFollow(FOLLOW_ruleFullID_in_ruleJavaType2495);
            this_FullID_0=ruleFullID();

            state._fsp--;


            		current.merge(this_FullID_0);
                
             
                    afterParserOrEnumRuleCall();
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1170:1: (kw= '[' kw= ']' )*
            loop24:
            do {
                int alt24=2;
                int LA24_0 = input.LA(1);

                if ( (LA24_0==27) ) {
                    alt24=1;
                }


                switch (alt24) {
            	case 1 :
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1171:2: kw= '[' kw= ']'
            	    {
            	    kw=(Token)match(input,27,FOLLOW_27_in_ruleJavaType2514); 

            	            current.merge(kw);
            	            newLeafNode(kw, grammarAccess.getJavaTypeAccess().getLeftSquareBracketKeyword_1_0()); 
            	        
            	    kw=(Token)match(input,28,FOLLOW_28_in_ruleJavaType2527); 

            	            current.merge(kw);
            	            newLeafNode(kw, grammarAccess.getJavaTypeAccess().getRightSquareBracketKeyword_1_1()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop24;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleJavaType"


    // $ANTLR start "entryRuleJavaIntExpr"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1190:1: entryRuleJavaIntExpr returns [String current=null] : iv_ruleJavaIntExpr= ruleJavaIntExpr EOF ;
    public final String entryRuleJavaIntExpr() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleJavaIntExpr = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1191:2: (iv_ruleJavaIntExpr= ruleJavaIntExpr EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1192:2: iv_ruleJavaIntExpr= ruleJavaIntExpr EOF
            {
             newCompositeNode(grammarAccess.getJavaIntExprRule()); 
            pushFollow(FOLLOW_ruleJavaIntExpr_in_entryRuleJavaIntExpr2570);
            iv_ruleJavaIntExpr=ruleJavaIntExpr();

            state._fsp--;

             current =iv_ruleJavaIntExpr.getText(); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleJavaIntExpr2581); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleJavaIntExpr"


    // $ANTLR start "ruleJavaIntExpr"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1199:1: ruleJavaIntExpr returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_INT_0= RULE_INT | this_JavaVarAccess_1= ruleJavaVarAccess ) ;
    public final AntlrDatatypeRuleToken ruleJavaIntExpr() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_INT_0=null;
        AntlrDatatypeRuleToken this_JavaVarAccess_1 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1202:28: ( (this_INT_0= RULE_INT | this_JavaVarAccess_1= ruleJavaVarAccess ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1203:1: (this_INT_0= RULE_INT | this_JavaVarAccess_1= ruleJavaVarAccess )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1203:1: (this_INT_0= RULE_INT | this_JavaVarAccess_1= ruleJavaVarAccess )
            int alt25=2;
            int LA25_0 = input.LA(1);

            if ( (LA25_0==RULE_INT) ) {
                alt25=1;
            }
            else if ( (LA25_0==RULE_ID) ) {
                alt25=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 25, 0, input);

                throw nvae;
            }
            switch (alt25) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1203:6: this_INT_0= RULE_INT
                    {
                    this_INT_0=(Token)match(input,RULE_INT,FOLLOW_RULE_INT_in_ruleJavaIntExpr2621); 

                    		current.merge(this_INT_0);
                        
                     
                        newLeafNode(this_INT_0, grammarAccess.getJavaIntExprAccess().getINTTerminalRuleCall_0()); 
                        

                    }
                    break;
                case 2 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1212:5: this_JavaVarAccess_1= ruleJavaVarAccess
                    {
                     
                            newCompositeNode(grammarAccess.getJavaIntExprAccess().getJavaVarAccessParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_ruleJavaVarAccess_in_ruleJavaIntExpr2654);
                    this_JavaVarAccess_1=ruleJavaVarAccess();

                    state._fsp--;


                    		current.merge(this_JavaVarAccess_1);
                        
                     
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleJavaIntExpr"


    // $ANTLR start "entryRuleJavaFloatExpr"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1230:1: entryRuleJavaFloatExpr returns [String current=null] : iv_ruleJavaFloatExpr= ruleJavaFloatExpr EOF ;
    public final String entryRuleJavaFloatExpr() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleJavaFloatExpr = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1231:2: (iv_ruleJavaFloatExpr= ruleJavaFloatExpr EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1232:2: iv_ruleJavaFloatExpr= ruleJavaFloatExpr EOF
            {
             newCompositeNode(grammarAccess.getJavaFloatExprRule()); 
            pushFollow(FOLLOW_ruleJavaFloatExpr_in_entryRuleJavaFloatExpr2700);
            iv_ruleJavaFloatExpr=ruleJavaFloatExpr();

            state._fsp--;

             current =iv_ruleJavaFloatExpr.getText(); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleJavaFloatExpr2711); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleJavaFloatExpr"


    // $ANTLR start "ruleJavaFloatExpr"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1239:1: ruleJavaFloatExpr returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_Float_0= ruleFloat | this_JavaVarAccess_1= ruleJavaVarAccess ) ;
    public final AntlrDatatypeRuleToken ruleJavaFloatExpr() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        AntlrDatatypeRuleToken this_Float_0 = null;

        AntlrDatatypeRuleToken this_JavaVarAccess_1 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1242:28: ( (this_Float_0= ruleFloat | this_JavaVarAccess_1= ruleJavaVarAccess ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1243:1: (this_Float_0= ruleFloat | this_JavaVarAccess_1= ruleJavaVarAccess )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1243:1: (this_Float_0= ruleFloat | this_JavaVarAccess_1= ruleJavaVarAccess )
            int alt26=2;
            int LA26_0 = input.LA(1);

            if ( (LA26_0==RULE_INT||LA26_0==35) ) {
                alt26=1;
            }
            else if ( (LA26_0==RULE_ID) ) {
                alt26=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 26, 0, input);

                throw nvae;
            }
            switch (alt26) {
                case 1 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1244:5: this_Float_0= ruleFloat
                    {
                     
                            newCompositeNode(grammarAccess.getJavaFloatExprAccess().getFloatParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_ruleFloat_in_ruleJavaFloatExpr2758);
                    this_Float_0=ruleFloat();

                    state._fsp--;


                    		current.merge(this_Float_0);
                        
                     
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1256:5: this_JavaVarAccess_1= ruleJavaVarAccess
                    {
                     
                            newCompositeNode(grammarAccess.getJavaFloatExprAccess().getJavaVarAccessParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_ruleJavaVarAccess_in_ruleJavaFloatExpr2791);
                    this_JavaVarAccess_1=ruleJavaVarAccess();

                    state._fsp--;


                    		current.merge(this_JavaVarAccess_1);
                        
                     
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleJavaFloatExpr"


    // $ANTLR start "entryRuleJavaVarAccess"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1274:1: entryRuleJavaVarAccess returns [String current=null] : iv_ruleJavaVarAccess= ruleJavaVarAccess EOF ;
    public final String entryRuleJavaVarAccess() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleJavaVarAccess = null;


        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1275:2: (iv_ruleJavaVarAccess= ruleJavaVarAccess EOF )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1276:2: iv_ruleJavaVarAccess= ruleJavaVarAccess EOF
            {
             newCompositeNode(grammarAccess.getJavaVarAccessRule()); 
            pushFollow(FOLLOW_ruleJavaVarAccess_in_entryRuleJavaVarAccess2837);
            iv_ruleJavaVarAccess=ruleJavaVarAccess();

            state._fsp--;

             current =iv_ruleJavaVarAccess.getText(); 
            match(input,EOF,FOLLOW_EOF_in_entryRuleJavaVarAccess2848); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleJavaVarAccess"


    // $ANTLR start "ruleJavaVarAccess"
    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1283:1: ruleJavaVarAccess returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_FullID_0= ruleFullID (kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']' )* ) ;
    public final AntlrDatatypeRuleToken ruleJavaVarAccess() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token kw=null;
        AntlrDatatypeRuleToken this_FullID_0 = null;

        AntlrDatatypeRuleToken this_JavaIntExpr_2 = null;


         enterRule(); 
            
        try {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1286:28: ( (this_FullID_0= ruleFullID (kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']' )* ) )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1287:1: (this_FullID_0= ruleFullID (kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']' )* )
            {
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1287:1: (this_FullID_0= ruleFullID (kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']' )* )
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1288:5: this_FullID_0= ruleFullID (kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']' )*
            {
             
                    newCompositeNode(grammarAccess.getJavaVarAccessAccess().getFullIDParserRuleCall_0()); 
                
            pushFollow(FOLLOW_ruleFullID_in_ruleJavaVarAccess2895);
            this_FullID_0=ruleFullID();

            state._fsp--;


            		current.merge(this_FullID_0);
                
             
                    afterParserOrEnumRuleCall();
                
            // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1298:1: (kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']' )*
            loop27:
            do {
                int alt27=2;
                int LA27_0 = input.LA(1);

                if ( (LA27_0==27) ) {
                    alt27=1;
                }


                switch (alt27) {
            	case 1 :
            	    // ../bcn.lang/src-gen/bcn/parser/antlr/internal/InternalLang.g:1299:2: kw= '[' this_JavaIntExpr_2= ruleJavaIntExpr kw= ']'
            	    {
            	    kw=(Token)match(input,27,FOLLOW_27_in_ruleJavaVarAccess2914); 

            	            current.merge(kw);
            	            newLeafNode(kw, grammarAccess.getJavaVarAccessAccess().getLeftSquareBracketKeyword_1_0()); 
            	        
            	     
            	            newCompositeNode(grammarAccess.getJavaVarAccessAccess().getJavaIntExprParserRuleCall_1_1()); 
            	        
            	    pushFollow(FOLLOW_ruleJavaIntExpr_in_ruleJavaVarAccess2936);
            	    this_JavaIntExpr_2=ruleJavaIntExpr();

            	    state._fsp--;


            	    		current.merge(this_JavaIntExpr_2);
            	        
            	     
            	            afterParserOrEnumRuleCall();
            	        
            	    kw=(Token)match(input,28,FOLLOW_28_in_ruleJavaVarAccess2954); 

            	            current.merge(kw);
            	            newLeafNode(kw, grammarAccess.getJavaVarAccessAccess().getRightSquareBracketKeyword_1_2()); 
            	        

            	    }
            	    break;

            	default :
            	    break loop27;
                }
            } while (true);


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleJavaVarAccess"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleController_in_entryRuleController75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleController85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_12_in_ruleController122 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_ruleFullID_in_ruleController143 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleController155 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_14_in_ruleController167 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleController184 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleController201 = new BitSet(new long[]{0x0000000100008012L});
    public static final BitSet FOLLOW_ruleDeclaration_in_ruleController222 = new BitSet(new long[]{0x0000000100008012L});
    public static final BitSet FOLLOW_ruleDeclaration_in_entryRuleDeclaration259 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleDeclaration269 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleBehaviorDef_in_ruleDeclaration316 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleInstance_in_ruleDeclaration343 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleConnection_in_ruleDeclaration370 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleBehaviorDef_in_entryRuleBehaviorDef405 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleBehaviorDef415 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_ruleBehaviorDef452 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleBehaviorDef469 = new BitSet(new long[]{0x0000000000090020L});
    public static final BitSet FOLLOW_RULE_JAVA_GENERIC_TYPES_in_ruleBehaviorDef491 = new BitSet(new long[]{0x0000000000090000L});
    public static final BitSet FOLLOW_16_in_ruleBehaviorDef510 = new BitSet(new long[]{0x0000000000060010L});
    public static final BitSet FOLLOW_ruleJavaParam_in_ruleBehaviorDef531 = new BitSet(new long[]{0x0000000000060000L});
    public static final BitSet FOLLOW_17_in_ruleBehaviorDef545 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_ruleJavaParam_in_ruleBehaviorDef566 = new BitSet(new long[]{0x0000000000060000L});
    public static final BitSet FOLLOW_18_in_ruleBehaviorDef580 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ruleBehaviorDef594 = new BitSet(new long[]{0x0000000000700000L});
    public static final BitSet FOLLOW_20_in_ruleBehaviorDef607 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ruleBehaviorDef619 = new BitSet(new long[]{0x0000000004200010L});
    public static final BitSet FOLLOW_ruleInputPortDef_in_ruleBehaviorDef641 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleBehaviorDef653 = new BitSet(new long[]{0x0000000004200010L});
    public static final BitSet FOLLOW_21_in_ruleBehaviorDef667 = new BitSet(new long[]{0x0000000000600000L});
    public static final BitSet FOLLOW_22_in_ruleBehaviorDef682 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ruleBehaviorDef694 = new BitSet(new long[]{0x0000000004200010L});
    public static final BitSet FOLLOW_rulePortDef_in_ruleBehaviorDef716 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleBehaviorDef728 = new BitSet(new long[]{0x0000000004200010L});
    public static final BitSet FOLLOW_21_in_ruleBehaviorDef742 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_21_in_ruleBehaviorDef756 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaParam_in_entryRuleJavaParam792 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleJavaParam802 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaType_in_ruleJavaParam848 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleJavaParam865 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleInputPortDef_in_entryRuleInputPortDef906 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleInputPortDef916 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleInfluenceDef_in_ruleInputPortDef962 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePortDef_in_ruleInputPortDef990 = new BitSet(new long[]{0x0000000000800002L});
    public static final BitSet FOLLOW_23_in_ruleInputPortDef1003 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_24_in_ruleInputPortDef1015 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_ruleInputPortDef1027 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_ruleJavaIntExpr_in_ruleInputPortDef1048 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleInfluenceDef_in_entryRuleInfluenceDef1087 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleInfluenceDef1097 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_26_in_ruleInfluenceDef1134 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleInfluenceDef1151 = new BitSet(new long[]{0x0000000008800000L});
    public static final BitSet FOLLOW_27_in_ruleInfluenceDef1169 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_ruleJavaIntExpr_in_ruleInfluenceDef1190 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_ruleInfluenceDef1202 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_23_in_ruleInfluenceDef1216 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_ruleInfluenceDef1228 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_ruleInfluenceDef1240 = new BitSet(new long[]{0x0000000800000050L});
    public static final BitSet FOLLOW_ruleJavaFloatExpr_in_ruleInfluenceDef1261 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_ruleInfluenceDef1273 = new BitSet(new long[]{0x0000000040000000L});
    public static final BitSet FOLLOW_30_in_ruleInfluenceDef1285 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_ruleInfluenceDef1297 = new BitSet(new long[]{0x0000000800000050L});
    public static final BitSet FOLLOW_ruleJavaFloatExpr_in_ruleInfluenceDef1318 = new BitSet(new long[]{0x0000000000020000L});
    public static final BitSet FOLLOW_17_in_ruleInfluenceDef1330 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_ruleInfluenceDef1342 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_ruleInfluenceDef1354 = new BitSet(new long[]{0x0000000800000050L});
    public static final BitSet FOLLOW_ruleJavaFloatExpr_in_ruleInfluenceDef1375 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePortDef_in_entryRulePortDef1411 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePortDef1421 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaType_in_rulePortDef1467 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePortDef1484 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_27_in_rulePortDef1502 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_ruleJavaIntExpr_in_rulePortDef1523 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_rulePortDef1535 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleInstance_in_entryRuleInstance1573 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleInstance1583 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleInstance1625 = new BitSet(new long[]{0x0000000000000030L});
    public static final BitSet FOLLOW_RULE_JAVA_GENERIC_TYPES_in_ruleInstance1647 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleInstance1670 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleInstance1687 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleConnection_in_entryRuleConnection1723 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleConnection1733 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_32_in_ruleConnection1770 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rulePortRef_in_ruleConnection1791 = new BitSet(new long[]{0x0000000200000000L});
    public static final BitSet FOLLOW_33_in_ruleConnection1803 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rulePortRef_in_ruleConnection1824 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_17_in_ruleConnection1837 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_rulePortRef_in_ruleConnection1858 = new BitSet(new long[]{0x0000000000022000L});
    public static final BitSet FOLLOW_13_in_ruleConnection1872 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePortRef_in_entryRulePortRef1908 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePortRef1918 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePortRef1963 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_34_in_rulePortRef1975 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_rulePortRef1992 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_27_in_rulePortRef2010 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_ruleJavaIntExpr_in_rulePortRef2031 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_rulePortRef2043 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleFullID_in_entryRuleFullID2082 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleFullID2093 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleFullID2133 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_34_in_ruleFullID2152 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleFullID2167 = new BitSet(new long[]{0x0000000400000002L});
    public static final BitSet FOLLOW_ruleFloat_in_entryRuleFloat2215 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleFloat2226 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_35_in_ruleFloat2265 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RULE_INT_in_ruleFloat2282 = new BitSet(new long[]{0x0000003400000002L});
    public static final BitSet FOLLOW_34_in_ruleFloat2301 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RULE_INT_in_ruleFloat2316 = new BitSet(new long[]{0x0000003000000002L});
    public static final BitSet FOLLOW_36_in_ruleFloat2338 = new BitSet(new long[]{0x0000000800000040L});
    public static final BitSet FOLLOW_37_in_ruleFloat2357 = new BitSet(new long[]{0x0000000800000040L});
    public static final BitSet FOLLOW_35_in_ruleFloat2372 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_RULE_INT_in_ruleFloat2389 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaType_in_entryRuleJavaType2437 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleJavaType2448 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleFullID_in_ruleJavaType2495 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_27_in_ruleJavaType2514 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_ruleJavaType2527 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_ruleJavaIntExpr_in_entryRuleJavaIntExpr2570 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleJavaIntExpr2581 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_RULE_INT_in_ruleJavaIntExpr2621 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaVarAccess_in_ruleJavaIntExpr2654 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaFloatExpr_in_entryRuleJavaFloatExpr2700 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleJavaFloatExpr2711 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleFloat_in_ruleJavaFloatExpr2758 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaVarAccess_in_ruleJavaFloatExpr2791 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleJavaVarAccess_in_entryRuleJavaVarAccess2837 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleJavaVarAccess2848 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleFullID_in_ruleJavaVarAccess2895 = new BitSet(new long[]{0x0000000008000002L});
    public static final BitSet FOLLOW_27_in_ruleJavaVarAccess2914 = new BitSet(new long[]{0x0000000000000050L});
    public static final BitSet FOLLOW_ruleJavaIntExpr_in_ruleJavaVarAccess2936 = new BitSet(new long[]{0x0000000010000000L});
    public static final BitSet FOLLOW_28_in_ruleJavaVarAccess2954 = new BitSet(new long[]{0x0000000008000002L});

}