package bcn;


public interface InputPort<T> {
    
    /** Return the oldest received message and remove it from the buffer. */
    public T get();
    
    /** Return the oldest received message without removing it from the buffer. */
    public T peek();
    
    /** Insert a new message on the input port. */
    public void put(T msg);
    
}
