package foraging_stub;

import bcn.*;
import foraging.*;


public abstract class Forage_stub extends Behavior {
    
    protected final InputPort<Detect.Detected> _detected;
    protected final InputPort<Byte> _gripperStatus;
    protected final OutputPort<Drive.Speed> _drive;
    protected final OutputPort<Byte> _gripperCmd;
    protected final OutputPort<Location> _homing;
    protected final OutputPort<Location> _depart;
    
    public Forage_stub() {
        _detected = new InputRegister<Detect.Detected>();
        _gripperStatus = new InputRegister<Byte>();
        _drive = new OutputPort<Drive.Speed>();
        _gripperCmd = new OutputPort<Byte>();
        _homing = new OutputPort<Location>();
        _depart = new OutputPort<Location>();
    }
    
    public final InputPort<Detect.Detected> get_detected() {
        return _detected;
    }
    
    public final InputPort<Byte> get_gripperStatus() {
        return _gripperStatus;
    }
    
    public final OutputPort<Drive.Speed> get_drive() {
        return _drive;
    }
    
    public final OutputPort<Byte> get_gripperCmd() {
        return _gripperCmd;
    }
    
    public final OutputPort<Location> get_homing() {
        return _homing;
    }
    
    public final OutputPort<Location> get_depart() {
        return _depart;
    }
    
}
