package foraging_stub;

import bcn.*;
import foraging.*;


public abstract class Gripper_stub extends Behavior {
    
    protected final InputPort<Byte> _cmd;
    protected final OutputPort<Byte> _status;
    
    public Gripper_stub() {
        _cmd = new InputRegister<Byte>();
        _status = new OutputPort<Byte>();
    }
    
    public final InputPort<Byte> get_cmd() {
        return _cmd;
    }
    
    public final OutputPort<Byte> get_status() {
        return _status;
    }
    
}
